Bug 61962 - Latency Vs Request and Response Time Vs Request graphs do not exceed 1000 RPS
Summary: Latency Vs Request and Response Time Vs Request graphs do not exceed 1000 RPS
Status: RESOLVED FIXED
Alias: None
Product: JMeter
Classification: Unclassified
Component: Main (show other bugs)
Version: 3.3
Hardware: All other
: P2 major with 1 vote (vote)
Target Milestone: ---
Assignee: JMeter issues mailing list
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2018-01-03 18:43 UTC by miccah.castorina
Modified: 2018-01-20 11:37 UTC (History)
1 user (show)



Attachments
"Hits Per Second" and "Latency Vs Request" graphs (239.72 KB, image/png)
2018-01-03 18:43 UTC, miccah.castorina
Details
Example CSV File (40K samples) (349.34 KB, application/x-gzip)
2018-01-04 17:47 UTC, miccah.castorina
Details
Example jmeter.properties (50.46 KB, text/x-matlab)
2018-01-04 17:48 UTC, miccah.castorina
Details
Example user.properties (14.01 KB, text/plain)
2018-01-04 17:50 UTC, miccah.castorina
Details

Note You need to log in before you can comment on or make changes to this bug.
Description miccah.castorina 2018-01-03 18:43:43 UTC
Created attachment 35645 [details]
"Hits Per Second" and "Latency Vs Request" graphs

This issue related to the JMeter report generation.

We are running tests where we are getting "Hits Per Second" and "Transactions Per Second" reaching 2000, but the "Latency Vs Request" graph and "Response Time Vs Request" graph never exceed 1000 RPS.

See attachment for "Hits Per Second" and "Latency Vs Request" graphs.
Comment 1 Sungjin Yook 2018-01-04 03:20:48 UTC
I observed same bug. In web report, I have high number of hits/sec (i.e. 2000 hits/sec) but "Latency vs RPS graph"'s x-axis only goes up to ~1000 RPS.
Comment 2 Philippe Mouawad 2018-01-04 10:52:16 UTC
Hello,
Would it be possible to provide a short CSV file + user.properties+jmeter.properties so that we have a reproducer ?
Thanks
Comment 3 Philippe Mouawad 2018-01-04 10:53:54 UTC
Also are you using distributed testing ?
Thank you
Comment 4 miccah.castorina 2018-01-04 17:47:04 UTC
Created attachment 35651 [details]
Example CSV File (40K samples)
Comment 5 miccah.castorina 2018-01-04 17:48:32 UTC
Created attachment 35652 [details]
Example jmeter.properties
Comment 6 miccah.castorina 2018-01-04 17:50:18 UTC
Created attachment 35653 [details]
Example user.properties
Comment 7 miccah.castorina 2018-01-04 17:52:01 UTC
Philippe,
I've added the files you requested to the attachments. The CSV file is the same from the attached image truncated to 40K samples.

Yes this is using distributed testing.
Thanks!
Comment 8 Philippe Mouawad 2018-01-04 21:16:39 UTC
Hello,
Thanks for provided information.
Can I ask you to summarize what you customized ?
Usually properties should only be overriden in user.properties and jmeter.properties/reportgenerator.properties should not be touched.

I suspect that the following settings might be a cause of your problem:
jmeter.reportgenerator.exporter.html.filters_only_sample_series=false
jmeter.reportgenerator.sample_filter=

Why did you change them ?

To filter samplers, just use jmeter.reportgenerator.exporter.html.series_filter and use Menu Help > Export Transactions for report


Also, if using 3.3, you don't need to set this unless you have an external process that uses csv file generated by JMeter
jmeter.save.saveservice.autoflush=true

Ensure you read :
http://jmeter.apache.org/usermanual/generating-dashboard.html#configuration_requirements

Can you confirm you followed this:
--------------------------------------------------------
 When using JMeter distributed mode with multiple jmeter-server instances, ensure you add in your Thread Groups something that uniquely identifies ThreadGroup for every JVM, example:

ThreadXXX_${__P(JVM_ID)}

where you pass a different JVM_ID property for each jmeter-server through:

-JJVM_ID=i

where i varies between 1 and the number of jmeter-server you are using. 
--------------------------------------------------------

I'll investigate further following your answers.
Thanks
Comment 9 miccah.castorina 2018-01-04 22:02:11 UTC
Thank you for the insights, but I don't believe those properties are the issue.
I downloaded a fresh copy of jmeter-3.2, changed the below two properties, and the resulting graphs are the same.

jmeter.save.saveservice.timestamp_format=dd/MM/yyyy HH:mm:ss zzz
jmeter.reportgenerator.overall_granularity=1000

Yes, each thread group is uniquely identified by its IP, and for this test we are only using one jmeter server with multiple workers.

To answer your questions about customization, we were running into an issue where nothing was showing up in the report. We found setting
jmeter.reportgenerator.sample_filter=.*
jmeter.reportgenerator.exporter.html.series_filter=.*
fixed that problem.
Comment 10 Philippe Mouawad 2018-01-04 22:04:04 UTC
(In reply to miccah.castorina from comment #9)
> Thank you for the insights, but I don't believe those properties are the
> issue.
> I downloaded a fresh copy of jmeter-3.2, changed the below two properties,
> and the resulting graphs are the same.
> 
> jmeter.save.saveservice.timestamp_format=dd/MM/yyyy HH:mm:ss zzz
> jmeter.reportgenerator.overall_granularity=1000

Ok, thanks, I'll investigate issue further in the upcoming days.
> 
> Yes, each thread group is uniquely identified by its IP, and for this test
> we are only using one jmeter server with multiple workers.
> 
> To answer your questions about customization, we were running into an issue
> where nothing was showing up in the report. We found setting
> jmeter.reportgenerator.sample_filter=.*
> jmeter.reportgenerator.exporter.html.series_filter=.*
> fixed that problem.
The correct way is to follow my previous advice.
Comment 11 Sungjin Yook 2018-01-04 22:29:27 UTC
I am also closely monitoring this thread. Our Jmeter master and slaves are NTP time sync'ed on our kubernetes cluster. I tried stock 3.3 Jmeter without modification, saw that RPS falls behind hits/sec. Test was done locally on my laptop and wasn't distributed tests. Thanks in advance working on this issue.
Comment 12 Philippe Mouawad 2018-01-04 23:17:11 UTC
Author: pmouawad
Date: Thu Jan  4 23:16:21 2018
New Revision: 1820239

URL: http://svn.apache.org/viewvc?rev=1820239&view=rev
Log:
Bug 61962 - Latency Vs Request graph does not exceed 1000 RPS
Contributed by UbikLoadPack
Bugzilla Id: 61962

Modified:
    jmeter/trunk/src/core/org/apache/jmeter/report/processor/graph/AbstractVersusRequestsGraphConsumer.java
    jmeter/trunk/xdocs/changes.xml
Comment 13 Philippe Mouawad 2018-01-04 23:35:04 UTC
Hello,
Issue should be fixed now, you can download in few minutes a working build:
http://jmeter.apache.org/nightly.html

Use jenkins link and download zip (non source)

Regards
Philippe M.
Comment 14 Sungjin Yook 2018-01-04 23:56:41 UTC
@Philippe
I am really impressed with fast response on this issue. 
Will test out on the cluster tomorrow and update. 
Thanks again for your effort and time on this !
Comment 15 miccah.castorina 2018-01-05 17:27:02 UTC
Confirmed this is now fixed.
Thanks!